///////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   /
// /___/  \  /    Vendor: Xilinx
// \   \   \/     Version : 2.1
//  \   \         Application : 7 Series FPGAs Transceivers Wizard
//  /   /         Filename : jesd204b_rx4_gtwizard_v2_1.v
// /___/   /\     
// \   \  /  \ 
//  \___\/\___\
//
//
// Module jesd204b_rx4_gtwizard_v2_1 (a GT Wrapper)
// Generated by Xilinx 7 Series FPGAs Transceivers Wizard
// 
// 
// (c) Copyright 2010-2012 Xilinx, Inc. All rights reserved.
// 
// This file contains confidential and proprietary information
// of Xilinx, Inc. and is protected under U.S. and
// international copyright and other intellectual property
// laws.
// 
// DISCLAIMER
// This disclaimer is not a license and does not grant any
// rights to the materials distributed herewith. Except as
// otherwise provided in a valid license issued to you by
// Xilinx, and to the maximum extent permitted by applicable
// law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
// WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
// AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
// BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
// INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
// (2) Xilinx shall not be liable (whether in contract or tort,
// including negligence, or under any other theory of
// liability) for any loss or damage of any kind or nature
// related to, arising under or in connection with these
// materials, including for any direct, or any indirect,
// special, incidental, or consequential loss or damage
// (including loss of data, profits, goodwill, or any type of
// loss or damage suffered as a result of any action brought
// by a third party) even if such damage or loss was
// reasonably foreseeable or Xilinx had been advised of the
// possibility of the same.
// 
// CRITICAL APPLICATIONS
// Xilinx products are not designed or intended to be fail-
// safe, or for use in any application requiring fail-safe
// performance, such as life-support or safety devices or
// systems, Class III medical devices, nuclear facilities,
// applications related to the deployment of airbags, or any
// other applications that could lead to death, personal
// injury, or severe property or environmental damage
// (individually and collectively, "Critical
// Applications"). Customer assumes the sole risk and
// liability of any use of Xilinx products in Critical
// Applications, subject only to applicable laws and
// regulations governing limitations on product liability.
// 
// THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
// PART OF THIS FILE AT ALL TIMES. 


`default_nettype wire

`timescale 1ns / 1ps
`define DLY #1

//***************************** Entity Declaration ****************************

(* CORE_GENERATION_INFO = "jesd204b_rx4_gtwizard_v2_1,gtwizard_v2_1,{protocol_file=Start_from_scratch}" *) module jesd204b_rx4_gtwizard_v2_1 #
(
    // Simulation attributes
    parameter   WRAPPER_SIM_GTRESET_SPEEDUP    =   "false",     // Set to "true" to speed up sim reset
    parameter   RX_DFE_KL_CFG2_IN              =   32'h3010D90C,
    parameter   PMA_RSV_IN                     =   32'h001E7080,
    parameter   SIM_VERSION                    =   "3.0"
)
(
    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT0  (X0Y0)
    //____________________________CHANNEL PORTS________________________________
    //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
    input   [8:0]   GT0_DRPADDR_IN,
    input           GT0_DRPCLK_IN,
    input   [15:0]  GT0_DRPDI_IN,
    output  [15:0]  GT0_DRPDO_OUT,
    input           GT0_DRPEN_IN,
    output          GT0_DRPRDY_OUT,
    input           GT0_DRPWE_IN,
    //----------------------- Channel - Ref Clock Ports ------------------------
    input           GT0_GTREFCLK0_IN,
    //------------------------------ Channel PLL -------------------------------
    output          GT0_CPLLFBCLKLOST_OUT,
    output          GT0_CPLLLOCK_OUT,
    input           GT0_CPLLLOCKDETCLK_IN,
    output          GT0_CPLLREFCLKLOST_OUT,
    input           GT0_CPLLRESET_IN,
    //----------------------------- Eye Scan Ports -----------------------------
    output          GT0_EYESCANDATAERROR_OUT,
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   GT0_LOOPBACK_IN,
    //----------------------------- Receive Ports ------------------------------
    input           GT0_RXUSERRDY_IN,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [3:0]   GT0_RXCHARISCOMMA_OUT,
    output  [3:0]   GT0_RXCHARISK_OUT,
    output  [3:0]   GT0_RXDISPERR_OUT,
    output  [3:0]   GT0_RXNOTINTABLE_OUT,
    //----------------- Receive Ports - Channel Bonding Ports ------------------
    output          GT0_RXCHANBONDSEQ_OUT,
    input           GT0_RXCHBONDEN_IN,
    input   [4:0]   GT0_RXCHBONDI_IN,
    input   [2:0]   GT0_RXCHBONDLEVEL_IN,
    input           GT0_RXCHBONDMASTER_IN,
    output  [4:0]   GT0_RXCHBONDO_OUT,
    input           GT0_RXCHBONDSLAVE_IN,
    //----------------- Receive Ports - Channel Bonding Ports  -----------------
    output          GT0_RXCHANISALIGNED_OUT,
    output          GT0_RXCHANREALIGN_OUT,
    //------------- Receive Ports - Comma Detection and Alignment --------------
    input           GT0_RXMCOMMAALIGNEN_IN,
    input           GT0_RXPCOMMAALIGNEN_IN,
    //----------------- Receive Ports - RX Data Path interface -----------------
    input           GT0_GTRXRESET_IN,
    output  [31:0]  GT0_RXDATA_OUT,
    output          GT0_RXOUTCLK_OUT,
    input           GT0_RXPCSRESET_IN,
    input           GT0_RXUSRCLK_IN,
    input           GT0_RXUSRCLK2_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input           GT0_GTXRXN_IN,
    input           GT0_GTXRXP_IN,
    output          GT0_RXCDRLOCK_OUT,
    output          GT0_RXELECIDLE_OUT,
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    output          GT0_RXRESETDONE_OUT,
    //----------------------------- Transmit Ports -----------------------------
    input   [4:0]   GT0_TXPOSTCURSOR_IN,
    input   [4:0]   GT0_TXPRECURSOR_IN,
    input           GT0_TXUSERRDY_IN,
    //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    input   [3:0]   GT0_TXCHARISK_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input           GT0_GTTXRESET_IN,
    input   [31:0]  GT0_TXDATA_IN,
    output          GT0_TXOUTCLK_OUT,
    output          GT0_TXOUTCLKFABRIC_OUT,
    output          GT0_TXOUTCLKPCS_OUT,
    input           GT0_TXPCSRESET_IN,
    input           GT0_TXUSRCLK_IN,
    input           GT0_TXUSRCLK2_IN,
    //-------------- Transmit Ports - TX Driver and OOB signaling --------------
    output          GT0_GTXTXN_OUT,
    output          GT0_GTXTXP_OUT,
    input   [3:0]   GT0_TXDIFFCTRL_IN,
    //--------------------- Transmit Ports - TX PLL Ports ----------------------
    output          GT0_TXRESETDONE_OUT,
    //------------------ Transmit Ports - TX Polarity Control ------------------
    input           GT0_TXPOLARITY_IN,

    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT1  (X0Y1)
    //____________________________CHANNEL PORTS________________________________
    //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
    input   [8:0]   GT1_DRPADDR_IN,
    input           GT1_DRPCLK_IN,
    input   [15:0]  GT1_DRPDI_IN,
    output  [15:0]  GT1_DRPDO_OUT,
    input           GT1_DRPEN_IN,
    output          GT1_DRPRDY_OUT,
    input           GT1_DRPWE_IN,
    //----------------------- Channel - Ref Clock Ports ------------------------
    input           GT1_GTREFCLK0_IN,
    //------------------------------ Channel PLL -------------------------------
    output          GT1_CPLLFBCLKLOST_OUT,
    output          GT1_CPLLLOCK_OUT,
    input           GT1_CPLLLOCKDETCLK_IN,
    output          GT1_CPLLREFCLKLOST_OUT,
    input           GT1_CPLLRESET_IN,
    //----------------------------- Eye Scan Ports -----------------------------
    output          GT1_EYESCANDATAERROR_OUT,
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   GT1_LOOPBACK_IN,
    //----------------------------- Receive Ports ------------------------------
    input           GT1_RXUSERRDY_IN,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [3:0]   GT1_RXCHARISCOMMA_OUT,
    output  [3:0]   GT1_RXCHARISK_OUT,
    output  [3:0]   GT1_RXDISPERR_OUT,
    output  [3:0]   GT1_RXNOTINTABLE_OUT,
    //----------------- Receive Ports - Channel Bonding Ports ------------------
    output          GT1_RXCHANBONDSEQ_OUT,
    input           GT1_RXCHBONDEN_IN,
    input   [4:0]   GT1_RXCHBONDI_IN,
    input   [2:0]   GT1_RXCHBONDLEVEL_IN,
    input           GT1_RXCHBONDMASTER_IN,
    output  [4:0]   GT1_RXCHBONDO_OUT,
    input           GT1_RXCHBONDSLAVE_IN,
    //----------------- Receive Ports - Channel Bonding Ports  -----------------
    output          GT1_RXCHANISALIGNED_OUT,
    output          GT1_RXCHANREALIGN_OUT,
    //------------- Receive Ports - Comma Detection and Alignment --------------
    input           GT1_RXMCOMMAALIGNEN_IN,
    input           GT1_RXPCOMMAALIGNEN_IN,
    //----------------- Receive Ports - RX Data Path interface -----------------
    input           GT1_GTRXRESET_IN,
    output  [31:0]  GT1_RXDATA_OUT,
    output          GT1_RXOUTCLK_OUT,
    input           GT1_RXPCSRESET_IN,
    input           GT1_RXUSRCLK_IN,
    input           GT1_RXUSRCLK2_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input           GT1_GTXRXN_IN,
    input           GT1_GTXRXP_IN,
    output          GT1_RXCDRLOCK_OUT,
    output          GT1_RXELECIDLE_OUT,
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    output          GT1_RXRESETDONE_OUT,
    //----------------------------- Transmit Ports -----------------------------
    input   [4:0]   GT1_TXPOSTCURSOR_IN,
    input   [4:0]   GT1_TXPRECURSOR_IN,
    input           GT1_TXUSERRDY_IN,
    //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    input   [3:0]   GT1_TXCHARISK_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input           GT1_GTTXRESET_IN,
    input   [31:0]  GT1_TXDATA_IN,
    output          GT1_TXOUTCLK_OUT,
    output          GT1_TXOUTCLKFABRIC_OUT,
    output          GT1_TXOUTCLKPCS_OUT,
    input           GT1_TXPCSRESET_IN,
    input           GT1_TXUSRCLK_IN,
    input           GT1_TXUSRCLK2_IN,
    //-------------- Transmit Ports - TX Driver and OOB signaling --------------
    output          GT1_GTXTXN_OUT,
    output          GT1_GTXTXP_OUT,
    input   [3:0]   GT1_TXDIFFCTRL_IN,
    //--------------------- Transmit Ports - TX PLL Ports ----------------------
    output          GT1_TXRESETDONE_OUT,
    //------------------ Transmit Ports - TX Polarity Control ------------------
    input           GT1_TXPOLARITY_IN,

    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT2  (X0Y2)
    //____________________________CHANNEL PORTS________________________________
    //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
    input   [8:0]   GT2_DRPADDR_IN,
    input           GT2_DRPCLK_IN,
    input   [15:0]  GT2_DRPDI_IN,
    output  [15:0]  GT2_DRPDO_OUT,
    input           GT2_DRPEN_IN,
    output          GT2_DRPRDY_OUT,
    input           GT2_DRPWE_IN,
    //----------------------- Channel - Ref Clock Ports ------------------------
    input           GT2_GTREFCLK0_IN,
    //------------------------------ Channel PLL -------------------------------
    output          GT2_CPLLFBCLKLOST_OUT,
    output          GT2_CPLLLOCK_OUT,
    input           GT2_CPLLLOCKDETCLK_IN,
    output          GT2_CPLLREFCLKLOST_OUT,
    input           GT2_CPLLRESET_IN,
    //----------------------------- Eye Scan Ports -----------------------------
    output          GT2_EYESCANDATAERROR_OUT,
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   GT2_LOOPBACK_IN,
    //----------------------------- Receive Ports ------------------------------
    input           GT2_RXUSERRDY_IN,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [3:0]   GT2_RXCHARISCOMMA_OUT,
    output  [3:0]   GT2_RXCHARISK_OUT,
    output  [3:0]   GT2_RXDISPERR_OUT,
    output  [3:0]   GT2_RXNOTINTABLE_OUT,
    //----------------- Receive Ports - Channel Bonding Ports ------------------
    output          GT2_RXCHANBONDSEQ_OUT,
    input           GT2_RXCHBONDEN_IN,
    input   [4:0]   GT2_RXCHBONDI_IN,
    input   [2:0]   GT2_RXCHBONDLEVEL_IN,
    input           GT2_RXCHBONDMASTER_IN,
    output  [4:0]   GT2_RXCHBONDO_OUT,
    input           GT2_RXCHBONDSLAVE_IN,
    //----------------- Receive Ports - Channel Bonding Ports  -----------------
    output          GT2_RXCHANISALIGNED_OUT,
    output          GT2_RXCHANREALIGN_OUT,
    //------------- Receive Ports - Comma Detection and Alignment --------------
    input           GT2_RXMCOMMAALIGNEN_IN,
    input           GT2_RXPCOMMAALIGNEN_IN,
    //----------------- Receive Ports - RX Data Path interface -----------------
    input           GT2_GTRXRESET_IN,
    output  [31:0]  GT2_RXDATA_OUT,
    output          GT2_RXOUTCLK_OUT,
    input           GT2_RXPCSRESET_IN,
    input           GT2_RXUSRCLK_IN,
    input           GT2_RXUSRCLK2_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input           GT2_GTXRXN_IN,
    input           GT2_GTXRXP_IN,
    output          GT2_RXCDRLOCK_OUT,
    output          GT2_RXELECIDLE_OUT,
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    output          GT2_RXRESETDONE_OUT,
    //----------------------------- Transmit Ports -----------------------------
    input   [4:0]   GT2_TXPOSTCURSOR_IN,
    input   [4:0]   GT2_TXPRECURSOR_IN,
    input           GT2_TXUSERRDY_IN,
    //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    input   [3:0]   GT2_TXCHARISK_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input           GT2_GTTXRESET_IN,
    input   [31:0]  GT2_TXDATA_IN,
    output          GT2_TXOUTCLK_OUT,
    output          GT2_TXOUTCLKFABRIC_OUT,
    output          GT2_TXOUTCLKPCS_OUT,
    input           GT2_TXPCSRESET_IN,
    input           GT2_TXUSRCLK_IN,
    input           GT2_TXUSRCLK2_IN,
    //-------------- Transmit Ports - TX Driver and OOB signaling --------------
    output          GT2_GTXTXN_OUT,
    output          GT2_GTXTXP_OUT,
    input   [3:0]   GT2_TXDIFFCTRL_IN,
    //--------------------- Transmit Ports - TX PLL Ports ----------------------
    output          GT2_TXRESETDONE_OUT,
    //------------------ Transmit Ports - TX Polarity Control ------------------
    input           GT2_TXPOLARITY_IN,

    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT3  (X0Y3)
    //____________________________CHANNEL PORTS________________________________
    //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
    input   [8:0]   GT3_DRPADDR_IN,
    input           GT3_DRPCLK_IN,
    input   [15:0]  GT3_DRPDI_IN,
    output  [15:0]  GT3_DRPDO_OUT,
    input           GT3_DRPEN_IN,
    output          GT3_DRPRDY_OUT,
    input           GT3_DRPWE_IN,
    //----------------------- Channel - Ref Clock Ports ------------------------
    input           GT3_GTREFCLK0_IN,
    //------------------------------ Channel PLL -------------------------------
    output          GT3_CPLLFBCLKLOST_OUT,
    output          GT3_CPLLLOCK_OUT,
    input           GT3_CPLLLOCKDETCLK_IN,
    output          GT3_CPLLREFCLKLOST_OUT,
    input           GT3_CPLLRESET_IN,
    //----------------------------- Eye Scan Ports -----------------------------
    output          GT3_EYESCANDATAERROR_OUT,
    //---------------------- Loopback and Powerdown Ports ----------------------
    input   [2:0]   GT3_LOOPBACK_IN,
    //----------------------------- Receive Ports ------------------------------
    input           GT3_RXUSERRDY_IN,
    //--------------------- Receive Ports - 8b10b Decoder ----------------------
    output  [3:0]   GT3_RXCHARISCOMMA_OUT,
    output  [3:0]   GT3_RXCHARISK_OUT,
    output  [3:0]   GT3_RXDISPERR_OUT,
    output  [3:0]   GT3_RXNOTINTABLE_OUT,
    //----------------- Receive Ports - Channel Bonding Ports ------------------
    output          GT3_RXCHANBONDSEQ_OUT,
    input           GT3_RXCHBONDEN_IN,
    input   [4:0]   GT3_RXCHBONDI_IN,
    input   [2:0]   GT3_RXCHBONDLEVEL_IN,
    input           GT3_RXCHBONDMASTER_IN,
    output  [4:0]   GT3_RXCHBONDO_OUT,
    input           GT3_RXCHBONDSLAVE_IN,
    //----------------- Receive Ports - Channel Bonding Ports  -----------------
    output          GT3_RXCHANISALIGNED_OUT,
    output          GT3_RXCHANREALIGN_OUT,
    //------------- Receive Ports - Comma Detection and Alignment --------------
    input           GT3_RXMCOMMAALIGNEN_IN,
    input           GT3_RXPCOMMAALIGNEN_IN,
    //----------------- Receive Ports - RX Data Path interface -----------------
    input           GT3_GTRXRESET_IN,
    output  [31:0]  GT3_RXDATA_OUT,
    output          GT3_RXOUTCLK_OUT,
    input           GT3_RXPCSRESET_IN,
    input           GT3_RXUSRCLK_IN,
    input           GT3_RXUSRCLK2_IN,
    //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    input           GT3_GTXRXN_IN,
    input           GT3_GTXRXP_IN,
    output          GT3_RXCDRLOCK_OUT,
    output          GT3_RXELECIDLE_OUT,
    //---------------------- Receive Ports - RX PLL Ports ----------------------
    output          GT3_RXRESETDONE_OUT,
    //----------------------------- Transmit Ports -----------------------------
    input   [4:0]   GT3_TXPOSTCURSOR_IN,
    input   [4:0]   GT3_TXPRECURSOR_IN,
    input           GT3_TXUSERRDY_IN,
    //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    input   [3:0]   GT3_TXCHARISK_IN,
    //---------------- Transmit Ports - TX Data Path interface -----------------
    input           GT3_GTTXRESET_IN,
    input   [31:0]  GT3_TXDATA_IN,
    output          GT3_TXOUTCLK_OUT,
    output          GT3_TXOUTCLKFABRIC_OUT,
    output          GT3_TXOUTCLKPCS_OUT,
    input           GT3_TXPCSRESET_IN,
    input           GT3_TXUSRCLK_IN,
    input           GT3_TXUSRCLK2_IN,
    //-------------- Transmit Ports - TX Driver and OOB signaling --------------
    output          GT3_GTXTXN_OUT,
    output          GT3_GTXTXP_OUT,
    input   [3:0]   GT3_TXDIFFCTRL_IN,
    //--------------------- Transmit Ports - TX PLL Ports ----------------------
    output          GT3_TXRESETDONE_OUT,
    //------------------ Transmit Ports - TX Polarity Control ------------------
    input           GT3_TXPOLARITY_IN,


    //____________________________COMMON PORTS________________________________
    //-------------------- Common Block  - Ref Clock Ports ---------------------
    input           GT0_GTREFCLK0_COMMON_IN,
    //----------------------- Common Block - QPLL Ports ------------------------
    output          GT0_QPLLLOCK_OUT,
    input           GT0_QPLLLOCKDETCLK_IN,
    output          GT0_QPLLREFCLKLOST_OUT,
    input           GT0_QPLLRESET_IN


);
//***************************** Parameter Declarations ************************
    parameter QPLL_FBDIV_TOP =  40;

    parameter QPLL_FBDIV_IN  =  (QPLL_FBDIV_TOP == 16)  ? 10'b0000100000 : 
				(QPLL_FBDIV_TOP == 20)  ? 10'b0000110000 :
				(QPLL_FBDIV_TOP == 32)  ? 10'b0001100000 :
				(QPLL_FBDIV_TOP == 40)  ? 10'b0010000000 :
				(QPLL_FBDIV_TOP == 64)  ? 10'b0011100000 :
				(QPLL_FBDIV_TOP == 66)  ? 10'b0101000000 :
				(QPLL_FBDIV_TOP == 80)  ? 10'b0100100000 :
				(QPLL_FBDIV_TOP == 100) ? 10'b0101110000 : 10'b0000000000;

   parameter QPLL_FBDIV_RATIO = (QPLL_FBDIV_TOP == 16)  ? 1'b1 : 
				(QPLL_FBDIV_TOP == 20)  ? 1'b1 :
				(QPLL_FBDIV_TOP == 32)  ? 1'b1 :
				(QPLL_FBDIV_TOP == 40)  ? 1'b1 :
				(QPLL_FBDIV_TOP == 64)  ? 1'b1 :
				(QPLL_FBDIV_TOP == 66)  ? 1'b0 :
				(QPLL_FBDIV_TOP == 80)  ? 1'b1 :
				(QPLL_FBDIV_TOP == 100) ? 1'b1 : 1'b1;

//***************************** Wire Declarations *****************************

    // ground and vcc signals
    wire            tied_to_ground_i;
    wire    [63:0]  tied_to_ground_vec_i;
    wire            tied_to_vcc_i;
    wire    [63:0]  tied_to_vcc_vec_i;
    
    wire            gt0_qplloutclk_i;
    wire            gt0_qplloutrefclk_i;

    wire            gt0_qpllclk_i;
    wire            gt0_qpllrefclk_i;

    wire            gt1_qpllclk_i;
    wire            gt1_qpllrefclk_i;

    wire            gt2_qpllclk_i;
    wire            gt2_qpllrefclk_i;

    wire            gt3_qpllclk_i;
    wire            gt3_qpllrefclk_i;

         
//********************************* Main Body of Code**************************

    assign tied_to_ground_i             = 1'b0;
    assign tied_to_ground_vec_i         = 64'h0000000000000000;
    assign tied_to_vcc_i                = 1'b1;
    assign tied_to_vcc_vec_i            = 64'hffffffffffffffff;


    assign  gt0_qpllclk_i    = gt0_qplloutclk_i;  
    assign  gt0_qpllrefclk_i = gt0_qplloutrefclk_i; 
    assign  gt1_qpllclk_i    = gt0_qplloutclk_i;  
    assign  gt1_qpllrefclk_i = gt0_qplloutrefclk_i; 
    assign  gt2_qpllclk_i    = gt0_qplloutclk_i;  
    assign  gt2_qpllrefclk_i = gt0_qplloutrefclk_i; 
    assign  gt3_qpllclk_i    = gt0_qplloutclk_i;  
    assign  gt3_qpllrefclk_i = gt0_qplloutrefclk_i; 
      
      
//------------------------- GT Instances  -------------------------------
    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT0  (X0Y0)

    jesd204b_rx4_gtwizard_v2_1_gt #
    (
        // Simulation attributes
        .GT_SIM_GTRESET_SPEEDUP   (WRAPPER_SIM_GTRESET_SPEEDUP),
        .SIM_VERSION              (SIM_VERSION),
        .RX_DFE_KL_CFG2_IN        (RX_DFE_KL_CFG2_IN),
        .PCS_RSVD_ATTR_IN         (48'h000000000000),
        .PMA_RSV_IN               (PMA_RSV_IN)
    )
    gt0_jesd204b_rx4_gtwizard_v2_1_i
    (
        //-------------------------------- Channel ---------------------------------
        .QPLLCLK_IN                     (gt0_qpllclk_i),
        .QPLLREFCLK_IN                  (gt0_qpllrefclk_i),
        //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
        .DRPADDR_IN                     (GT0_DRPADDR_IN),
        .DRPCLK_IN                      (GT0_DRPCLK_IN),
        .DRPDI_IN                       (GT0_DRPDI_IN),
        .DRPDO_OUT                      (GT0_DRPDO_OUT),
        .DRPEN_IN                       (GT0_DRPEN_IN),
        .DRPRDY_OUT                     (GT0_DRPRDY_OUT),
        .DRPWE_IN                       (GT0_DRPWE_IN),
        //----------------------- Channel - Ref Clock Ports ------------------------
        .GTREFCLK0_IN                   (GT0_GTREFCLK0_IN),
        //------------------------------ Channel PLL -------------------------------
        .CPLLFBCLKLOST_OUT              (GT0_CPLLFBCLKLOST_OUT),
        .CPLLLOCK_OUT                   (GT0_CPLLLOCK_OUT),
        .CPLLLOCKDETCLK_IN              (GT0_CPLLLOCKDETCLK_IN),
        .CPLLREFCLKLOST_OUT             (GT0_CPLLREFCLKLOST_OUT),
        .CPLLRESET_IN                   (GT0_CPLLRESET_IN),
        //----------------------------- Eye Scan Ports -----------------------------
        .EYESCANDATAERROR_OUT           (GT0_EYESCANDATAERROR_OUT),
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK_IN                    (GT0_LOOPBACK_IN),
        //----------------------------- Receive Ports ------------------------------
        .RXUSERRDY_IN                   (GT0_RXUSERRDY_IN),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXCHARISCOMMA_OUT              (GT0_RXCHARISCOMMA_OUT),
        .RXCHARISK_OUT                  (GT0_RXCHARISK_OUT),
        .RXDISPERR_OUT                  (GT0_RXDISPERR_OUT),
        .RXNOTINTABLE_OUT               (GT0_RXNOTINTABLE_OUT),
        //----------------- Receive Ports - Channel Bonding Ports ------------------
        .RXCHANBONDSEQ_OUT              (GT0_RXCHANBONDSEQ_OUT),
        .RXCHBONDEN_IN                  (GT0_RXCHBONDEN_IN),
        .RXCHBONDI_IN                   (GT0_RXCHBONDI_IN),
        .RXCHBONDLEVEL_IN               (GT0_RXCHBONDLEVEL_IN),
        .RXCHBONDMASTER_IN              (GT0_RXCHBONDMASTER_IN),
        .RXCHBONDO_OUT                  (GT0_RXCHBONDO_OUT),
        .RXCHBONDSLAVE_IN               (GT0_RXCHBONDSLAVE_IN),
        //----------------- Receive Ports - Channel Bonding Ports  -----------------
        .RXCHANISALIGNED_OUT            (GT0_RXCHANISALIGNED_OUT),
        .RXCHANREALIGN_OUT              (GT0_RXCHANREALIGN_OUT),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .RXMCOMMAALIGNEN_IN             (GT0_RXMCOMMAALIGNEN_IN),
        .RXPCOMMAALIGNEN_IN             (GT0_RXPCOMMAALIGNEN_IN),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTRXRESET_IN                   (GT0_GTRXRESET_IN),
        .RXDATA_OUT                     (GT0_RXDATA_OUT),
        .RXOUTCLK_OUT                   (GT0_RXOUTCLK_OUT),
        .RXPCSRESET_IN                  (GT0_RXPCSRESET_IN),
        .RXUSRCLK_IN                    (GT0_RXUSRCLK_IN),
        .RXUSRCLK2_IN                   (GT0_RXUSRCLK2_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTXRXN_IN                      (GT0_GTXRXN_IN),
        .GTXRXP_IN                      (GT0_GTXRXP_IN),
        .RXCDRLOCK_OUT                  (GT0_RXCDRLOCK_OUT),
        .RXELECIDLE_OUT                 (GT0_RXELECIDLE_OUT),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .RXRESETDONE_OUT                (GT0_RXRESETDONE_OUT),
        //----------------------------- Transmit Ports -----------------------------
        .TXPOSTCURSOR_IN                (GT0_TXPOSTCURSOR_IN),
        .TXPRECURSOR_IN                 (GT0_TXPRECURSOR_IN),
        .TXUSERRDY_IN                   (GT0_TXUSERRDY_IN),
        //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        .TXCHARISK_IN                   (GT0_TXCHARISK_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .GTTXRESET_IN                   (GT0_GTTXRESET_IN),
        .TXDATA_IN                      (GT0_TXDATA_IN),
        .TXOUTCLK_OUT                   (GT0_TXOUTCLK_OUT),
        .TXOUTCLKFABRIC_OUT             (GT0_TXOUTCLKFABRIC_OUT),
        .TXOUTCLKPCS_OUT                (GT0_TXOUTCLKPCS_OUT),
        .TXPCSRESET_IN                  (GT0_TXPCSRESET_IN),
        .TXUSRCLK_IN                    (GT0_TXUSRCLK_IN),
        .TXUSRCLK2_IN                   (GT0_TXUSRCLK2_IN),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTXTXN_OUT                     (GT0_GTXTXN_OUT),
        .GTXTXP_OUT                     (GT0_GTXTXP_OUT),
        .TXDIFFCTRL_IN                  (GT0_TXDIFFCTRL_IN),
        //--------------------- Transmit Ports - TX PLL Ports ----------------------
        .TXRESETDONE_OUT                (GT0_TXRESETDONE_OUT),
        //------------------ Transmit Ports - TX Polarity Control ------------------
        .TXPOLARITY_IN                  (GT0_TXPOLARITY_IN)

    );

    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT1  (X0Y1)

    jesd204b_rx4_gtwizard_v2_1_gt #
    (
        // Simulation attributes
        .GT_SIM_GTRESET_SPEEDUP   (WRAPPER_SIM_GTRESET_SPEEDUP),
        .SIM_VERSION              (SIM_VERSION),
        .RX_DFE_KL_CFG2_IN        (RX_DFE_KL_CFG2_IN),
        .PCS_RSVD_ATTR_IN         (48'h000000000000),
        .PMA_RSV_IN               (PMA_RSV_IN)
    )
    gt1_jesd204b_rx4_gtwizard_v2_1_i
    (
        //-------------------------------- Channel ---------------------------------
        .QPLLCLK_IN                     (gt1_qpllclk_i),
        .QPLLREFCLK_IN                  (gt1_qpllrefclk_i),
        //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
        .DRPADDR_IN                     (GT1_DRPADDR_IN),
        .DRPCLK_IN                      (GT1_DRPCLK_IN),
        .DRPDI_IN                       (GT1_DRPDI_IN),
        .DRPDO_OUT                      (GT1_DRPDO_OUT),
        .DRPEN_IN                       (GT1_DRPEN_IN),
        .DRPRDY_OUT                     (GT1_DRPRDY_OUT),
        .DRPWE_IN                       (GT1_DRPWE_IN),
        //----------------------- Channel - Ref Clock Ports ------------------------
        .GTREFCLK0_IN                   (GT1_GTREFCLK0_IN),
        //------------------------------ Channel PLL -------------------------------
        .CPLLFBCLKLOST_OUT              (GT1_CPLLFBCLKLOST_OUT),
        .CPLLLOCK_OUT                   (GT1_CPLLLOCK_OUT),
        .CPLLLOCKDETCLK_IN              (GT1_CPLLLOCKDETCLK_IN),
        .CPLLREFCLKLOST_OUT             (GT1_CPLLREFCLKLOST_OUT),
        .CPLLRESET_IN                   (GT1_CPLLRESET_IN),
        //----------------------------- Eye Scan Ports -----------------------------
        .EYESCANDATAERROR_OUT           (GT1_EYESCANDATAERROR_OUT),
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK_IN                    (GT1_LOOPBACK_IN),
        //----------------------------- Receive Ports ------------------------------
        .RXUSERRDY_IN                   (GT1_RXUSERRDY_IN),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXCHARISCOMMA_OUT              (GT1_RXCHARISCOMMA_OUT),
        .RXCHARISK_OUT                  (GT1_RXCHARISK_OUT),
        .RXDISPERR_OUT                  (GT1_RXDISPERR_OUT),
        .RXNOTINTABLE_OUT               (GT1_RXNOTINTABLE_OUT),
        //----------------- Receive Ports - Channel Bonding Ports ------------------
        .RXCHANBONDSEQ_OUT              (GT1_RXCHANBONDSEQ_OUT),
        .RXCHBONDEN_IN                  (GT1_RXCHBONDEN_IN),
        .RXCHBONDI_IN                   (GT1_RXCHBONDI_IN),
        .RXCHBONDLEVEL_IN               (GT1_RXCHBONDLEVEL_IN),
        .RXCHBONDMASTER_IN              (GT1_RXCHBONDMASTER_IN),
        .RXCHBONDO_OUT                  (GT1_RXCHBONDO_OUT),
        .RXCHBONDSLAVE_IN               (GT1_RXCHBONDSLAVE_IN),
        //----------------- Receive Ports - Channel Bonding Ports  -----------------
        .RXCHANISALIGNED_OUT            (GT1_RXCHANISALIGNED_OUT),
        .RXCHANREALIGN_OUT              (GT1_RXCHANREALIGN_OUT),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .RXMCOMMAALIGNEN_IN             (GT1_RXMCOMMAALIGNEN_IN),
        .RXPCOMMAALIGNEN_IN             (GT1_RXPCOMMAALIGNEN_IN),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTRXRESET_IN                   (GT1_GTRXRESET_IN),
        .RXDATA_OUT                     (GT1_RXDATA_OUT),
        .RXOUTCLK_OUT                   (GT1_RXOUTCLK_OUT),
        .RXPCSRESET_IN                  (GT1_RXPCSRESET_IN),
        .RXUSRCLK_IN                    (GT1_RXUSRCLK_IN),
        .RXUSRCLK2_IN                   (GT1_RXUSRCLK2_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTXRXN_IN                      (GT1_GTXRXN_IN),
        .GTXRXP_IN                      (GT1_GTXRXP_IN),
        .RXCDRLOCK_OUT                  (GT1_RXCDRLOCK_OUT),
        .RXELECIDLE_OUT                 (GT1_RXELECIDLE_OUT),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .RXRESETDONE_OUT                (GT1_RXRESETDONE_OUT),
        //----------------------------- Transmit Ports -----------------------------
        .TXPOSTCURSOR_IN                (GT1_TXPOSTCURSOR_IN),
        .TXPRECURSOR_IN                 (GT1_TXPRECURSOR_IN),
        .TXUSERRDY_IN                   (GT1_TXUSERRDY_IN),
        //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        .TXCHARISK_IN                   (GT1_TXCHARISK_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .GTTXRESET_IN                   (GT1_GTTXRESET_IN),
        .TXDATA_IN                      (GT1_TXDATA_IN),
        .TXOUTCLK_OUT                   (GT1_TXOUTCLK_OUT),
        .TXOUTCLKFABRIC_OUT             (GT1_TXOUTCLKFABRIC_OUT),
        .TXOUTCLKPCS_OUT                (GT1_TXOUTCLKPCS_OUT),
        .TXPCSRESET_IN                  (GT1_TXPCSRESET_IN),
        .TXUSRCLK_IN                    (GT1_TXUSRCLK_IN),
        .TXUSRCLK2_IN                   (GT1_TXUSRCLK2_IN),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTXTXN_OUT                     (GT1_GTXTXN_OUT),
        .GTXTXP_OUT                     (GT1_GTXTXP_OUT),
        .TXDIFFCTRL_IN                  (GT1_TXDIFFCTRL_IN),
        //--------------------- Transmit Ports - TX PLL Ports ----------------------
        .TXRESETDONE_OUT                (GT1_TXRESETDONE_OUT),
        //------------------ Transmit Ports - TX Polarity Control ------------------
        .TXPOLARITY_IN                  (GT1_TXPOLARITY_IN)

    );

    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT2  (X0Y2)

    jesd204b_rx4_gtwizard_v2_1_gt #
    (
        // Simulation attributes
        .GT_SIM_GTRESET_SPEEDUP   (WRAPPER_SIM_GTRESET_SPEEDUP),
        .SIM_VERSION              (SIM_VERSION),
        .RX_DFE_KL_CFG2_IN        (RX_DFE_KL_CFG2_IN),
        .PCS_RSVD_ATTR_IN         (48'h000000000000),
        .PMA_RSV_IN               (PMA_RSV_IN)
    )
    gt2_jesd204b_rx4_gtwizard_v2_1_i
    (
        //-------------------------------- Channel ---------------------------------
        .QPLLCLK_IN                     (gt2_qpllclk_i),
        .QPLLREFCLK_IN                  (gt2_qpllrefclk_i),
        //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
        .DRPADDR_IN                     (GT2_DRPADDR_IN),
        .DRPCLK_IN                      (GT2_DRPCLK_IN),
        .DRPDI_IN                       (GT2_DRPDI_IN),
        .DRPDO_OUT                      (GT2_DRPDO_OUT),
        .DRPEN_IN                       (GT2_DRPEN_IN),
        .DRPRDY_OUT                     (GT2_DRPRDY_OUT),
        .DRPWE_IN                       (GT2_DRPWE_IN),
        //----------------------- Channel - Ref Clock Ports ------------------------
        .GTREFCLK0_IN                   (GT2_GTREFCLK0_IN),
        //------------------------------ Channel PLL -------------------------------
        .CPLLFBCLKLOST_OUT              (GT2_CPLLFBCLKLOST_OUT),
        .CPLLLOCK_OUT                   (GT2_CPLLLOCK_OUT),
        .CPLLLOCKDETCLK_IN              (GT2_CPLLLOCKDETCLK_IN),
        .CPLLREFCLKLOST_OUT             (GT2_CPLLREFCLKLOST_OUT),
        .CPLLRESET_IN                   (GT2_CPLLRESET_IN),
        //----------------------------- Eye Scan Ports -----------------------------
        .EYESCANDATAERROR_OUT           (GT2_EYESCANDATAERROR_OUT),
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK_IN                    (GT2_LOOPBACK_IN),
        //----------------------------- Receive Ports ------------------------------
        .RXUSERRDY_IN                   (GT2_RXUSERRDY_IN),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXCHARISCOMMA_OUT              (GT2_RXCHARISCOMMA_OUT),
        .RXCHARISK_OUT                  (GT2_RXCHARISK_OUT),
        .RXDISPERR_OUT                  (GT2_RXDISPERR_OUT),
        .RXNOTINTABLE_OUT               (GT2_RXNOTINTABLE_OUT),
        //----------------- Receive Ports - Channel Bonding Ports ------------------
        .RXCHANBONDSEQ_OUT              (GT2_RXCHANBONDSEQ_OUT),
        .RXCHBONDEN_IN                  (GT2_RXCHBONDEN_IN),
        .RXCHBONDI_IN                   (GT2_RXCHBONDI_IN),
        .RXCHBONDLEVEL_IN               (GT2_RXCHBONDLEVEL_IN),
        .RXCHBONDMASTER_IN              (GT2_RXCHBONDMASTER_IN),
        .RXCHBONDO_OUT                  (GT2_RXCHBONDO_OUT),
        .RXCHBONDSLAVE_IN               (GT2_RXCHBONDSLAVE_IN),
        //----------------- Receive Ports - Channel Bonding Ports  -----------------
        .RXCHANISALIGNED_OUT            (GT2_RXCHANISALIGNED_OUT),
        .RXCHANREALIGN_OUT              (GT2_RXCHANREALIGN_OUT),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .RXMCOMMAALIGNEN_IN             (GT2_RXMCOMMAALIGNEN_IN),
        .RXPCOMMAALIGNEN_IN             (GT2_RXPCOMMAALIGNEN_IN),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTRXRESET_IN                   (GT2_GTRXRESET_IN),
        .RXDATA_OUT                     (GT2_RXDATA_OUT),
        .RXOUTCLK_OUT                   (GT2_RXOUTCLK_OUT),
        .RXPCSRESET_IN                  (GT2_RXPCSRESET_IN),
        .RXUSRCLK_IN                    (GT2_RXUSRCLK_IN),
        .RXUSRCLK2_IN                   (GT2_RXUSRCLK2_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTXRXN_IN                      (GT2_GTXRXN_IN),
        .GTXRXP_IN                      (GT2_GTXRXP_IN),
        .RXCDRLOCK_OUT                  (GT2_RXCDRLOCK_OUT),
        .RXELECIDLE_OUT                 (GT2_RXELECIDLE_OUT),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .RXRESETDONE_OUT                (GT2_RXRESETDONE_OUT),
        //----------------------------- Transmit Ports -----------------------------
        .TXPOSTCURSOR_IN                (GT2_TXPOSTCURSOR_IN),
        .TXPRECURSOR_IN                 (GT2_TXPRECURSOR_IN),
        .TXUSERRDY_IN                   (GT2_TXUSERRDY_IN),
        //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        .TXCHARISK_IN                   (GT2_TXCHARISK_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .GTTXRESET_IN                   (GT2_GTTXRESET_IN),
        .TXDATA_IN                      (GT2_TXDATA_IN),
        .TXOUTCLK_OUT                   (GT2_TXOUTCLK_OUT),
        .TXOUTCLKFABRIC_OUT             (GT2_TXOUTCLKFABRIC_OUT),
        .TXOUTCLKPCS_OUT                (GT2_TXOUTCLKPCS_OUT),
        .TXPCSRESET_IN                  (GT2_TXPCSRESET_IN),
        .TXUSRCLK_IN                    (GT2_TXUSRCLK_IN),
        .TXUSRCLK2_IN                   (GT2_TXUSRCLK2_IN),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTXTXN_OUT                     (GT2_GTXTXN_OUT),
        .GTXTXP_OUT                     (GT2_GTXTXP_OUT),
        .TXDIFFCTRL_IN                  (GT2_TXDIFFCTRL_IN),
        //--------------------- Transmit Ports - TX PLL Ports ----------------------
        .TXRESETDONE_OUT                (GT2_TXRESETDONE_OUT),
        //------------------ Transmit Ports - TX Polarity Control ------------------
        .TXPOLARITY_IN                  (GT2_TXPOLARITY_IN)

    );

    //_________________________________________________________________________
    //_________________________________________________________________________
    //GT3  (X0Y3)

    jesd204b_rx4_gtwizard_v2_1_gt #
    (
        // Simulation attributes
        .GT_SIM_GTRESET_SPEEDUP   (WRAPPER_SIM_GTRESET_SPEEDUP),
        .SIM_VERSION              (SIM_VERSION),
        .RX_DFE_KL_CFG2_IN        (RX_DFE_KL_CFG2_IN),
        .PCS_RSVD_ATTR_IN         (48'h000000000000),
        .PMA_RSV_IN               (PMA_RSV_IN)
    )
    gt3_jesd204b_rx4_gtwizard_v2_1_i
    (
        //-------------------------------- Channel ---------------------------------
        .QPLLCLK_IN                     (gt3_qpllclk_i),
        .QPLLREFCLK_IN                  (gt3_qpllrefclk_i),
        //-------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
        .DRPADDR_IN                     (GT3_DRPADDR_IN),
        .DRPCLK_IN                      (GT3_DRPCLK_IN),
        .DRPDI_IN                       (GT3_DRPDI_IN),
        .DRPDO_OUT                      (GT3_DRPDO_OUT),
        .DRPEN_IN                       (GT3_DRPEN_IN),
        .DRPRDY_OUT                     (GT3_DRPRDY_OUT),
        .DRPWE_IN                       (GT3_DRPWE_IN),
        //----------------------- Channel - Ref Clock Ports ------------------------
        .GTREFCLK0_IN                   (GT3_GTREFCLK0_IN),
        //------------------------------ Channel PLL -------------------------------
        .CPLLFBCLKLOST_OUT              (GT3_CPLLFBCLKLOST_OUT),
        .CPLLLOCK_OUT                   (GT3_CPLLLOCK_OUT),
        .CPLLLOCKDETCLK_IN              (GT3_CPLLLOCKDETCLK_IN),
        .CPLLREFCLKLOST_OUT             (GT3_CPLLREFCLKLOST_OUT),
        .CPLLRESET_IN                   (GT3_CPLLRESET_IN),
        //----------------------------- Eye Scan Ports -----------------------------
        .EYESCANDATAERROR_OUT           (GT3_EYESCANDATAERROR_OUT),
        //---------------------- Loopback and Powerdown Ports ----------------------
        .LOOPBACK_IN                    (GT3_LOOPBACK_IN),
        //----------------------------- Receive Ports ------------------------------
        .RXUSERRDY_IN                   (GT3_RXUSERRDY_IN),
        //--------------------- Receive Ports - 8b10b Decoder ----------------------
        .RXCHARISCOMMA_OUT              (GT3_RXCHARISCOMMA_OUT),
        .RXCHARISK_OUT                  (GT3_RXCHARISK_OUT),
        .RXDISPERR_OUT                  (GT3_RXDISPERR_OUT),
        .RXNOTINTABLE_OUT               (GT3_RXNOTINTABLE_OUT),
        //----------------- Receive Ports - Channel Bonding Ports ------------------
        .RXCHANBONDSEQ_OUT              (GT3_RXCHANBONDSEQ_OUT),
        .RXCHBONDEN_IN                  (GT3_RXCHBONDEN_IN),
        .RXCHBONDI_IN                   (GT3_RXCHBONDI_IN),
        .RXCHBONDLEVEL_IN               (GT3_RXCHBONDLEVEL_IN),
        .RXCHBONDMASTER_IN              (GT3_RXCHBONDMASTER_IN),
        .RXCHBONDO_OUT                  (GT3_RXCHBONDO_OUT),
        .RXCHBONDSLAVE_IN               (GT3_RXCHBONDSLAVE_IN),
        //----------------- Receive Ports - Channel Bonding Ports  -----------------
        .RXCHANISALIGNED_OUT            (GT3_RXCHANISALIGNED_OUT),
        .RXCHANREALIGN_OUT              (GT3_RXCHANREALIGN_OUT),
        //------------- Receive Ports - Comma Detection and Alignment --------------
        .RXMCOMMAALIGNEN_IN             (GT3_RXMCOMMAALIGNEN_IN),
        .RXPCOMMAALIGNEN_IN             (GT3_RXPCOMMAALIGNEN_IN),
        //----------------- Receive Ports - RX Data Path interface -----------------
        .GTRXRESET_IN                   (GT3_GTRXRESET_IN),
        .RXDATA_OUT                     (GT3_RXDATA_OUT),
        .RXOUTCLK_OUT                   (GT3_RXOUTCLK_OUT),
        .RXPCSRESET_IN                  (GT3_RXPCSRESET_IN),
        .RXUSRCLK_IN                    (GT3_RXUSRCLK_IN),
        .RXUSRCLK2_IN                   (GT3_RXUSRCLK2_IN),
        //----- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        .GTXRXN_IN                      (GT3_GTXRXN_IN),
        .GTXRXP_IN                      (GT3_GTXRXP_IN),
        .RXCDRLOCK_OUT                  (GT3_RXCDRLOCK_OUT),
        .RXELECIDLE_OUT                 (GT3_RXELECIDLE_OUT),
        //---------------------- Receive Ports - RX PLL Ports ----------------------
        .RXRESETDONE_OUT                (GT3_RXRESETDONE_OUT),
        //----------------------------- Transmit Ports -----------------------------
        .TXPOSTCURSOR_IN                (GT3_TXPOSTCURSOR_IN),
        .TXPRECURSOR_IN                 (GT3_TXPRECURSOR_IN),
        .TXUSERRDY_IN                   (GT3_TXUSERRDY_IN),
        //-------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        .TXCHARISK_IN                   (GT3_TXCHARISK_IN),
        //---------------- Transmit Ports - TX Data Path interface -----------------
        .GTTXRESET_IN                   (GT3_GTTXRESET_IN),
        .TXDATA_IN                      (GT3_TXDATA_IN),
        .TXOUTCLK_OUT                   (GT3_TXOUTCLK_OUT),
        .TXOUTCLKFABRIC_OUT             (GT3_TXOUTCLKFABRIC_OUT),
        .TXOUTCLKPCS_OUT                (GT3_TXOUTCLKPCS_OUT),
        .TXPCSRESET_IN                  (GT3_TXPCSRESET_IN),
        .TXUSRCLK_IN                    (GT3_TXUSRCLK_IN),
        .TXUSRCLK2_IN                   (GT3_TXUSRCLK2_IN),
        //-------------- Transmit Ports - TX Driver and OOB signaling --------------
        .GTXTXN_OUT                     (GT3_GTXTXN_OUT),
        .GTXTXP_OUT                     (GT3_GTXTXP_OUT),
        .TXDIFFCTRL_IN                  (GT3_TXDIFFCTRL_IN),
        //--------------------- Transmit Ports - TX PLL Ports ----------------------
        .TXRESETDONE_OUT                (GT3_TXRESETDONE_OUT),
        //------------------ Transmit Ports - TX Polarity Control ------------------
        .TXPOLARITY_IN                  (GT3_TXPOLARITY_IN)

    );


    //_________________________________________________________________________
    //_________________________________________________________________________
    //_________________________GTXE2_COMMON____________________________________

    GTXE2_COMMON #
    (
            // Simulation attributes
            .SIM_RESET_SPEEDUP   (WRAPPER_SIM_GTRESET_SPEEDUP),
            .SIM_QPLLREFCLK_SEL  (3'b001),
            .SIM_VERSION         (SIM_VERSION),


           //----------------COMMON BLOCK Attributes---------------
            .BIAS_CFG                               (64'h0000040000001000),
            .COMMON_CFG                             (32'h00000000),
            .QPLL_CFG                               (27'h0680181),
            .QPLL_CLKOUT_CFG                        (4'b0000),
            .QPLL_COARSE_FREQ_OVRD                  (6'b010000),
            .QPLL_COARSE_FREQ_OVRD_EN               (1'b0),
            .QPLL_CP                                (10'b0000011111),
            .QPLL_CP_MONITOR_EN                     (1'b0),
            .QPLL_DMONITOR_SEL                      (1'b0),
            .QPLL_FBDIV                             (QPLL_FBDIV_IN),
            .QPLL_FBDIV_MONITOR_EN                  (1'b0),
            .QPLL_FBDIV_RATIO                       (QPLL_FBDIV_RATIO),
            .QPLL_INIT_CFG                          (24'h000006),
            .QPLL_LOCK_CFG                          (16'h21E8),
            .QPLL_LPF                               (4'b1111),
            .QPLL_REFCLK_DIV                        (1)

    )
    gtxe2_common_0_i
    (
        //----------- Common Block  - Dynamic Reconfiguration Port (DRP) -----------
        .DRPADDR                        (tied_to_ground_vec_i[7:0]),
        .DRPCLK                         (tied_to_ground_i),
        .DRPDI                          (tied_to_ground_vec_i[15:0]),
        .DRPDO                          (),
        .DRPEN                          (tied_to_ground_i),
        .DRPRDY                         (),
        .DRPWE                          (tied_to_ground_i),
        //-------------------- Common Block  - Ref Clock Ports ---------------------
        .GTGREFCLK                      (tied_to_ground_i),
        .GTNORTHREFCLK0                 (tied_to_ground_i),
        .GTNORTHREFCLK1                 (tied_to_ground_i),
        .GTREFCLK0                      (GT0_GTREFCLK0_COMMON_IN),
        .GTREFCLK1                      (tied_to_ground_i),
        .GTSOUTHREFCLK0                 (tied_to_ground_i),
        .GTSOUTHREFCLK1                 (tied_to_ground_i),
        //----------------------- Common Block - QPLL Ports ------------------------
        .QPLLDMONITOR                   (),
        .QPLLFBCLKLOST                  (),
        .QPLLLOCK                       (GT0_QPLLLOCK_OUT),
        .QPLLLOCKDETCLK                 (GT0_QPLLLOCKDETCLK_IN),
        .QPLLLOCKEN                     (tied_to_vcc_i),
        .QPLLOUTCLK                     (gt0_qplloutclk_i),
        .QPLLOUTREFCLK                  (gt0_qplloutrefclk_i),
        .QPLLOUTRESET                   (tied_to_ground_i),
        .QPLLPD                         (tied_to_ground_i),
        .QPLLREFCLKLOST                 (GT0_QPLLREFCLKLOST_OUT),
        .QPLLREFCLKSEL                  (3'b001),
        .QPLLRESET                      (GT0_QPLLRESET_IN),
        .QPLLRSVD1                      (16'b0000000000000000),
        .QPLLRSVD2                      (5'b11111),
        .REFCLKOUTMONITOR               (),
        //--------------------------- Common Block Ports ---------------------------
        .BGBYPASSB                      (tied_to_vcc_i),
        .BGMONITORENB                   (tied_to_vcc_i),
        .BGPDB                          (tied_to_vcc_i),
        .BGRCALOVRD                     (5'b00000),
        .PMARSVD                        (8'b00000000),
        .RCALENB                        (tied_to_vcc_i)

    );




endmodule

    
